"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _prototypeProperties = function (child, staticProps, instanceProps) { if (staticProps) Object.defineProperties(child, staticProps); if (instanceProps) Object.defineProperties(child.prototype, instanceProps); };

var _get = function get(object, property, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc && desc.writable) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var FamousSurface = _interopRequire(require("famous/core/Surface"));

var defaults = _interopRequire(require("lodash/object/defaults"));

var React = _interopRequire(require("react"));

var FamousComponent = _interopRequire(require("./FamousComponent"));

var FamousReactNode = exports.FamousReactNode = (function (FamousSurface) {
  function FamousReactNode(options, context) {
    _classCallCheck(this, FamousReactNode);

    _get(Object.getPrototypeOf(FamousReactNode.prototype), "constructor", this).call(this, options);

    this._reactContext = context;

    this.deploy = this.recall = function () {};

    this.on("deploy", this.onDeploy);
    this.on("recall", this.onRecall);
  }

  _inherits(FamousReactNode, FamousSurface);

  _prototypeProperties(FamousReactNode, null, {
    onDeploy: {
      value: function onDeploy() {
        var content = this.getContent();
        var context = this._reactContext;
        var target = this._currentTarget;

        if (React.isValidElement(content)) {
          if (context) {
            React.withContext(context, function () {
              React.render(content, target);
            });
          } else {
            React.render(content, target);
          }
        } else {
          throw new Error("Content is not a valid react component");
        }
      },
      writable: true,
      configurable: true
    },
    onRecall: {
      value: function onRecall() {
        var target = this._currentTarget;

        React.unmountComponentAtNode(target);
      },
      writable: true,
      configurable: true
    }
  });

  return FamousReactNode;
})(FamousSurface);

var ReactNode = exports.ReactNode = (function (FamousComponent) {
  function ReactNode() {
    _classCallCheck(this, ReactNode);

    if (FamousComponent != null) {
      FamousComponent.apply(this, arguments);
    }
  }

  _inherits(ReactNode, FamousComponent);

  _prototypeProperties(ReactNode, null, {
    famousCreate: {
      value: function famousCreate() {
        return new FamousReactNode(defaults(this.props.options, {
          properties: {
            overflow: "hidden"
          }
        }));
      },
      writable: true,
      configurable: true
    },
    famousCreateNode: {
      value: function famousCreateNode(parentNode) {
        var reactNode = this.getFamous();
        var node = parentNode.add(reactNode);
        return [node, null];
      },
      writable: true,
      configurable: true
    },
    famousUpdate: {
      value: function famousUpdate(nextProps) {
        var reactNode = this.getFamous();
        var content = this.props.children;

        reactNode.setOptions(defaults({}, nextProps.options, { content: content }));
      },
      writable: true,
      configurable: true
    },
    render: {
      value: function render() {
        return React.createElement("div", { "data-famous": "ReactNode" });
      },
      writable: true,
      configurable: true
    }
  });

  return ReactNode;
})(FamousComponent);

defaults(ReactNode, FamousReactNode);

exports["default"] = ReactNode;
Object.defineProperty(exports, "__esModule", {
  value: true
});