"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _prototypeProperties = function (child, staticProps, instanceProps) { if (staticProps) Object.defineProperties(child, staticProps); if (instanceProps) Object.defineProperties(child.prototype, instanceProps); };

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var FamousInputSurface = _interopRequire(require("famous/surfaces/InputSurface"));

var defaults = _interopRequire(require("lodash/object/defaults"));

var React = _interopRequire(require("react"));

var FamousComponent = _interopRequire(require("../lib/FamousComponent"));

var InputSurface = (function (FamousComponent) {
  function InputSurface() {
    _classCallCheck(this, InputSurface);

    if (FamousComponent != null) {
      FamousComponent.apply(this, arguments);
    }
  }

  _inherits(InputSurface, FamousComponent);

  _prototypeProperties(InputSurface, null, {
    famousCreate: {
      value: function famousCreate() {
        return new FamousInputSurface(this.props.options);
      },
      writable: true,
      configurable: true
    },
    famousCreateNode: {
      value: function famousCreateNode(parentNode) {
        var inputSurface = this.getFamous();
        var node = parentNode.add(inputSurface);
        return [node, null];
      },
      writable: true,
      configurable: true
    },
    famousUpdate: {
      value: function famousUpdate(nextProps) {
        var inputSurface = this.getFamous();

        inputSurface.setOptions(nextProps.options);
      },
      writable: true,
      configurable: true
    },
    render: {
      value: function render() {
        return React.createElement("div", { "data-famous": "InputSurface" });
      },
      writable: true,
      configurable: true
    }
  });

  return InputSurface;
})(FamousComponent);

defaults(InputSurface, FamousInputSurface);

module.exports = InputSurface;