"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _prototypeProperties = function (child, staticProps, instanceProps) { if (staticProps) Object.defineProperties(child, staticProps); if (instanceProps) Object.defineProperties(child.prototype, instanceProps); };

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var FamousTextareaSurface = _interopRequire(require("famous/surfaces/TextareaSurface"));

var defaults = _interopRequire(require("lodash/object/defaults"));

var React = _interopRequire(require("react"));

var FamousComponent = _interopRequire(require("../lib/FamousComponent"));

var TextareaSurface = (function (FamousComponent) {
  function TextareaSurface() {
    _classCallCheck(this, TextareaSurface);

    if (FamousComponent != null) {
      FamousComponent.apply(this, arguments);
    }
  }

  _inherits(TextareaSurface, FamousComponent);

  _prototypeProperties(TextareaSurface, null, {
    famousCreate: {
      value: function famousCreate() {
        return new FamousTextareaSurface(this.props.options);
      },
      writable: true,
      configurable: true
    },
    famousCreateNode: {
      value: function famousCreateNode(parentNode) {
        var textareaSurface = this.getFamous();
        var node = parentNode.add(textareaSurface);
        return [node, null];
      },
      writable: true,
      configurable: true
    },
    famousUpdate: {
      value: function famousUpdate(nextProps) {
        var textareaSurface = this.getFamous();

        textareaSurface.setOptions(nextProps.options);
      },
      writable: true,
      configurable: true
    },
    render: {
      value: function render() {
        return React.createElement("div", { "data-famous": "TextareaSurface" });
      },
      writable: true,
      configurable: true
    }
  });

  return TextareaSurface;
})(FamousComponent);

defaults(TextareaSurface, FamousTextareaSurface);

module.exports = TextareaSurface;