"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _prototypeProperties = function (child, staticProps, instanceProps) { if (staticProps) Object.defineProperties(child, staticProps); if (instanceProps) Object.defineProperties(child.prototype, instanceProps); };

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var FamousRenderNode = _interopRequire(require("famous/core/RenderNode"));

var FamousSequentialLayout = _interopRequire(require("famous/views/SequentialLayout"));

var defaults = _interopRequire(require("lodash/object/defaults"));

var React = _interopRequire(require("react"));

var FamousComponent = _interopRequire(require("../lib/FamousComponent"));

var SequentialLayout = (function (FamousComponent) {
  function SequentialLayout() {
    _classCallCheck(this, SequentialLayout);

    if (FamousComponent != null) {
      FamousComponent.apply(this, arguments);
    }
  }

  _inherits(SequentialLayout, FamousComponent);

  _prototypeProperties(SequentialLayout, null, {
    famousCreate: {
      value: function famousCreate() {
        return new FamousSequentialLayout(this.props.options);
      },
      writable: true,
      configurable: true
    },
    famousCreateNode: {
      value: function famousCreateNode(parentNode) {
        var sequentialLayout = this.getFamous();
        var node = parentNode.add(sequentialLayout);
        var next = [];
        var sequence = this.getFamousChildrenRef().map(function (child, idx) {
          var renderNode = new FamousRenderNode();
          next.push([child, renderNode]);
          return renderNode;
        });
        sequentialLayout.sequenceFrom(sequence);
        return [node, next];
      },
      writable: true,
      configurable: true
    },
    famousUpdate: {
      value: function famousUpdate(nextProps) {
        var sequentialLayout = this.getFamous();

        sequentialLayout.setOptions(nextProps.options);
      },
      writable: true,
      configurable: true
    },
    render: {
      value: function render() {
        return React.createElement(
          "div",
          { "data-famous": "SequentialLayout" },
          this.getFamousChildren()
        );
      },
      writable: true,
      configurable: true
    }
  });

  return SequentialLayout;
})(FamousComponent);

defaults(SequentialLayout, FamousSequentialLayout);

module.exports = SequentialLayout;